
// ******************************* Programmbeispiele    Versuch 3   2015 **************************

// *************************** OHNE Optimierung bersetzen **********************************

//							******** P R O G R A M M B E I S P I E L E ***********


//  ***** PROGRAMMBEISPIEL 01 ******

// Frequenzmessung mit Timer/Counter 1

// LCD an Ports D und C

// Das Mesignal kommt ber Port B, Bit 1

// Programmgrundlage: V3_15_template_LCD_D.c 

// Neue Variable: 

uint16_t wert;					// ein 16-Bit_Wort, das den binren Zahlenwert aufnimmt

// Einfgen:

DDRB=0b11111101;				// Eingang ist T1 = Port B1 = Pin 2
	
TCCR1B=0x06; 					// T1 auf externen Takt. Normalbetrieb	
								// Eingang ist T1 = Port B1 = Pin 2
								
while (1)						// Die allgemeine Endlosschleife
{

TCNT1=0;						// den Zhler lschen

millisecs (1000);				// So lange ist der Zhler aktiv

wert=TCNT1;						// den Zhlwert lesen

//  Den Zhlwert dezimal anzeigen

lcd_kdo (lcd_row1);				// An den Anfang der ersten LCD-Zeile

lcd_dat((wert/10000) +0x30);	// Die Zehntausenderstelle anzeigen

wert=wert%10000;

lcd_dat((wert/1000) +0x30);		// Die Tausenderstelle anzeigen

wert=wert%1000;

lcd_dat(wert/100 +0x30);		// Die Hunderterstelle anzeigen

wert=wert%100;

lcd_dat(wert/10 +0x30);			// Die Zehnerstelle anzeigen

wert=wert%10;

lcd_dat(wert +0x30);			// Die Einerstelle anzeigen

}


//  ***** PROGRAMMBEISPIEL 02 ******

// Periodendauermessung mit Timer/Counter 1

// Nutzung der Input_Capture-Funktion

// LCD an Ports B und C

// Das Mesignal kommt ber Port D, Bit 6

// Programmgrundlage: V3_15_template_LCD_B.c 

// Neue Variable: 


uint16_t wert;					// ein 16-Bit_Wort, das den binren Zahlenwert aufnimmt

// Einfgen:

DDRD  = 0b10111111;  			// Eingang ist ICP1 = Port D6 = Pin 20
	
TCCR1B=0x02; 					// T1 Maschinentakt : 8 (Periode 2 s). Normalbetrieb	
								
								
while (1)						// Die allgemeine Endlosschleife
{

TCNT1=0;						// Den Zhler lschen

while (!(TIFR &0x20));			// Auf das Capture-Ereignis warten

wert=TCNT1;						// Den aufgeschnappten Wert lesen



lcd_kdo (lcd_row1);				// An den Anfang der ersten LCD-Zeile


lcd_dat((wert/10000) +0x30);	// Die Zehntausenderstelle anzeigen

wert=wert%10000;

lcd_dat((wert/1000) +0x30);		// Die Tausenderstelle anzeigen

wert=wert%1000;

lcd_dat(wert/100 +0x30);		// Die Hunderterstelle anzeigen

wert=wert%100;

lcd_dat(wert/10 +0x30);			// Die Zehnerstelle anzeigen

wert=wert%10;

lcd_dat(wert +0x30);			// Die Einerstelle anzeigen


TIFR=(TIFR |0b00100000);		// Das Merkflipflop zurcksetzen (Schreiben einer Eins)

}


//  ***** PROGRAMMBEISPIEL 03 ******

// Pulsweitenmodulation mit Timer/Counter 0

// Ausgang Port B, Bit 3 

// Steuerung ber Terminal (serielle Schnittstelle)

// + = Aufwrts, - = abwrts, 0 = Halt, V = Vollgas.

// Programmgrundlage: V3_15_template_serial.c 


//  Der Interrupt-Handler zum Empfangen: 

//					

ISR(USART_RXC_vect)				// Mu so heien
{

Received_Byte = UDR;			// Das Byte abholen

senden (Received_Byte);			// Zurcksenden (Echo)

switch (Received_Byte)
 {
	case 0x2b:					// + 
	{
	if (pwm<255) pwm++;
	TCCR0=0b01101011;
	OCR0=pwm;
	break;
	}

	case 0x2d:					// -
	{
	if (pwm >0) pwm--;
	TCCR0=0b01101011;
	OCR0=pwm;
	break;
	}


	case 0x30:					// 0
	{
	TCCR0=0;					// Zeitgeberfunktion aus
	pwm=0;
	OCR0=pwm;
	PORTB=(PORTB & 0b11110111);	// Bit auf 0	
	break;
	}

	case 0x56:					// V
	{
	TCCR0=0b01101011;
	pwm=255;
	OCR0=pwm;
	break;
	}

 }
}


// Nach der Initialisierung:

pwm=100;							// PWM. Ausgabe ber Port B, Bit 3 = Pin 4

TCCR0=0b01101011;

OCR0=pwm;

// In der while-Schleife ist nichts zu tun
								
while (1)						// Die allgemeine Endlosschleife
{



}



//  ***** PROGRAMMBEISPIEL 04 ******

// Pulsweitenmodulation mit Timer/Counter 0

// Ausgang Port B, Bit 3 

// Steuerung ber Joystick und Koordinatentaster

// Programmbeispiel 03 umbauen

// Die neue Port-Initialisierung
 

PORTA = 0b11111000;				// ingnge fr Joystick
PORTB = 0xff;			
PORTC = 0xff;
PORTD = 0xff;
DDRA  = 0; 
DDRB  = 0xff;
DDRC  = 0xff;
DDRD  = 0xff;



// Die neue while-Schleife:


while (1)						// Die allgemeine Endlosschleife
{


if (!(PINA &0x80))
	{
	if (pwm<255) pwm++;
	TCCR0=0b01101011;
	OCR0=pwm;
	}

if (!(PINA & 0x40))
	{
	if (pwm >0) pwm--;
	TCCR0=0b01101011;
	OCR0=pwm;
	}

if (!(PINA & 0x20))
	{
	TCCR0=0;
	pwm=0;
	OCR0=pwm;
	PORTB=(PORTB & 0b11110111);
	}

if (!(PINA & 0x10))
	{
	TCCR0=0b01101011;
	pwm=255;
	OCR0=pwm;
	}


millisecs (20);


}



//  ***** PROGRAMMBEISPIEL 05 ******

// Pulsweitenmodulation mit Timer/Counter 0

// Ausgang Port B, Bit 3 

// Steuerung ber Joystick, analoger Steuerweg Hhenruder (Ziehen/Drcken)

// Programmbeispiel 04 umbauen

// Die neue Port-Initialisierung
 


//							******* Hierher kommt die Initialisierung *********


usart_init();					// Die UART initialisieren

asm volatile("sei"::);			// Interrupts zulassen. Das geht nur mit einem Assemblerbefehl.
								// da dessen Syntax so schauders aussieht, dafr knnen wir nichts...
								

senden (0x41);					// Zur Probe senden wir das Zeichen 'A'
	
	
pwm=100;							// PWM. Ausgabe ber Port B, Bit 3 = Pin 4

TCCR0=0b01101011;

OCR0=pwm;

ADMUX=0x20;
ADCSRA=0x86;
								
while (1)						// Die allgemeine Endlosschleife
{

ADCSRA=0xc6;				// ADC starten

while (!(ADCSRA & 0x10)); 	// warten

OCR0=ADCH;

ADCSRA = (ADCSRA | 0x10);

}



//  ***** PROGRAMMBEISPIEL 06 ******

//  XY (1). Eine waagerechte Linie maximaler Lnge (256 Pixel)


{            


// Neue Variable im Hauptprogramm:

uint8_t x, y;					// Koordinaten


while (1)						// Die allgemeine Endlosschleife
{
	x=0; y=0;
	PORTB=x; PORTC=y;

	for (x=0; x <= 255; x++) PORTB=x;

}



//  ***** PROGRAMMBEISPIEL 07 ******

//  XY (2). Eine senkrechte Linie maximaler Lnge (256 Pixel) anhngen
			

while (1)						// Die allgemeine Endlosschleife
{
x=0; y=0;
PORTB=x; PORTC=y;

for (x=0; x <= 255; x++) PORTB=x;

for (y=0; y <= 255; y++) PORTC=y;

}


//  ***** PROGRAMMBEISPIEL 08 ******

//  XY (3). So wird es funktionieren. Es ist aber immer ein Pixel zuwenig
			

while (1)						// Die allgemeine Endlosschleife
{
x=0; y=0;

PORTB=x; PORTC=y;

for (x=0; x < 255; x++) PORTB=x;

for (y=0; y < 255; y++) PORTC=y;

for (x=255; x > 0; x--) PORTB=x;

for (y=255; y > 0; y--) PORTC=y;


//			Zur Veranschaulichung der Ecken des Darstellbereichs:
//			Pixel in die uersten Ecken schreiben und etwas lnger stehen lassen
//			Bei Bedarf Kommentare entfernen
// PORTB=255; PORTC=255; millisecs (10);
// PORTB=255; PORTC=0; millisecs (10);
// PORTB=0; PORTC=255; millisecs (10);


}



//  ***** PROGRAMMBEISPIEL 09 ******

//  XY (4). Schreiben eines Quadrats maximaler Gre


while (1)						// Die allgemeine Endlosschleife
{
	x=0; y=0;
	PORTB=x; PORTC=y;

	for (x=0; x < 255; x++) PORTB=x;
	PORTB=x;

	for (y=0; y < 255; y++) PORTC=y;
	PORTC=y;
	
	for (x=255; x > 0; x--) PORTB=x;
	PORTB=x;

	for (y=255; y >0; y--) PORTC=y;
	PORTC=y;
}



//  ***** PROGRAMMBEISPIEL 10 ******

// 	XY (5). Einschreiben des kleineren Quadrats. Feste Seitenlnge

// Im Hauptprogramm ndern: Koordinaten mit Basiskoordinaten

uint8_t x, y, xb, yb;				 


xb=20; yb=20;					// Die Basiskoordinaten initalisieren



while (1)						// Die allgemeine Endlosschleife
{
	x=0; y=0;
	PORTB=x; PORTC=y;			// Das umhllende Quadrat

	for (x=0; x < 255; x++) PORTB=x;
	PORTB=x;

	for (y=0; y < 255; y++) PORTC=y;
	PORTC=y;

	for (x=255; x > 0; x--) PORTB=x;
	PORTB=x;

	for (y=255; y >0; y--) PORTC=y;
	PORTC=y;


	PORTB=xb; PORTC=yb;						// Das kleine Quadrat
	
	for (x=0; x <= 20; x++) PORTB=x+xb;

	for (y=0; y <= 20; y++) PORTC=y+yb;

	for (x=20; x !=255; x--) PORTB=x+xb;

	for (y=20; y !=255; y--) PORTC=y+yb;

}



//  ***** PROGRAMMBEISPIEL 11 ******

//  XY (6). Bewegen des kleineren Quadrats mit dem Koordinatentaster
//					(Hat Switch) am Joystick. 
//					**** Das erste selbst programmierte Computerspiel ****

while (1)						// Die allgemeine Endlosschleife
{
	x=0; y=0;
	PORTB=x; PORTC=y;

	for (x=0; x < 255; x++) PORTB=x;
	PORTB=x;

	for (y=0; y < 255; y++) PORTC=y;
	PORTC=y;

	for (x=255; x > 0; x--) PORTB=x;
	PORTB=x;

	for (y=255; y >0; y--) PORTC=y;
	PORTC=y;

	PORTB=xb; PORTC=yb;

	for (x=0; x <= 20; x++) PORTB=x+xb;

	for (y=0; y <= 20; y++) PORTC=y+yb;

	for (x=20; x !=255; x--) PORTB=x+xb;

	for (y=20; y !=255; y--) PORTC=y+yb;

	x=PINA;							// Koordinatentaster einlesen
									// auswerten
	if (!(x &0x80)) yb--; // down
	if (!(x &0x40)) yb++; // up
	if (!(x &0x20)) xb--; // left
	if (!(x &0x10)) xb++; // right

}






//  ***** PROGRAMMBEISPIEL 12 ******

//  XY (7). Bewegen des kleineren Quadrats mit dem analogen Joystick


while (1)						// Die allgemeine Endlosschleife
{
	x=0; y=0;
	PORTB=x; PORTC=y;

	for (x=0; x < 255; x++) PORTB=x;
	PORTB=x;

	for (y=0; y < 255; y++) PORTC=y;
	PORTC=y;

	for (x=255; x > 0; x--) PORTB=x;
	PORTB=x;

	for (y=255; y >0; y--) PORTC=y;
	PORTC=y;

	PORTB=xb; PORTC=yb;
	for (x=0; x <= 20; x++) PORTB=x+xb;

	for (y=0; y <= 20; y++) PORTC=y+yb;

	for (x=20; x !=255; x--) PORTB=x+xb;

	for (y=20; y !=255; y--) PORTC=y+yb;


	ADCSRA=0x02;
	ADMUX=0x20;
	ADCSRA=0x86;
	ADCSRA=0xc6;

	while (!(ADCSRA & 0x10)); 	// warten

	yb=ADCH;					// Den Analogwert als Y-Koordninate bernehmen

	ADCSRA=0x16;				// Das ADIF-Bit ausschalten
	ADCSRA=0x06;				// Den Wandler ausschalten


	ADMUX=0x21;
	ADCSRA=0x86;
	ADCSRA=0xc6;				// ADC starten

	while (!(ADCSRA & 0x10)); 	// warten

	xb=ADCH;					// Den Analogwert als X-Koordninate bernehmen

	ADCSRA=0x16;				// Das ADIF-Bit ausschalten
	ADCSRA=0x06;				// Den Wandler ausschalten


}


//  ***** PROGRAMMBEISPIEL 13 ******

//  XY (8). Einbau der Wertewandlung fr Y-Koordinate. Ziehen = nach unten

	yb=ADCH;					// Den Analogwert als Y-Koordinate bernehmen
	yb=255-yb;					// Wertewandlung






//  ***** PROGRAMMBEISPIEL 14 ******

//  XY (9). Symbole zeichnen mit schrgen Linien (45)


// Am Anfang des Programms ergnzen
 
#define X_OUT	PORTB
#define Y_OUT  	PORTC


uint8_t x,y, xbase,ybase,len;   
			
uint16_t durch;



// Neue Funktionen:


void loc (uint8_t xb,uint8_t yb) // Positionieren
{
	xbase=xb; x=0;
	ybase=yb; y=0;
	X_OUT=xbase; Y_OUT=ybase;
}



void up (uint8_t lg)			// Nach oben
{ 
	uint8_t	la;
	if (lg==0) la=len;
	else la=lg;
	while (la)
	{
		y++; la--;
		Y_OUT=ybase+y;
		
	}

}


void down (uint8_t lg)			// Nach unten
{ 
	uint8_t	la;
	if (lg==0) la=len;
	else la=lg;
	while (la)
	{
		y--; la--;
		Y_OUT=ybase+y;
		
	}
}


void right (uint8_t lg)		// Nach rechts
{ 
	uint8_t	la;
	if (lg==0) la=len;
	else la=lg;
	while (la)
	{
		x++; la--;
		X_OUT=xbase+x;
			
	}
}


void left (uint8_t lg)			// Nach links
{ 
	uint8_t	la;
	if (lg==0) la=len;
	else la=lg;
	while (la)
	{
		x--; la--;
		X_OUT=xbase+x;
		
	}
}

void ur (uint8_t lg)			// Nach oben rechts
{ 
	uint8_t	la;
	if (lg==0) la=len;
	else la=lg;
	while (la)
	{
		x++; y++; la--;
		X_OUT=xbase+x; Y_OUT=ybase+y;
		
	}	
}


void ul (uint8_t lg)			// Nach oben links
{ 
	uint8_t	la;
	if (lg==0) la=len;
	else la=lg;
	while (la)
	{
		x--; y++; la--;
		X_OUT=xbase+x; Y_OUT=ybase+y;
		
	}		
}


void dr (uint8_t lg)			// Nach unten rechts
{ 
	uint8_t	la;
	if (lg==0) la=len;
	else la=lg;
	while (la)
	{
		x++; y--; la--;
		X_OUT=xbase+x; Y_OUT=ybase+y;
		
	}	
}



void dl (uint8_t lg)			// Nach unten links
{ 
	uint8_t	la;
	if (lg==0) la=len;
	else la=lg;
	while (la)
	{
		x--; y--; la--;
		X_OUT=xbase+x; Y_OUT=ybase+y;
		
	}		
}




// Das Hauptprogramm am Anfang abndern:


loc (0,0);

len=255;
durch =0;



while (1)				// Die ewige Schleife
{

len=255; loc (0,0);


right(0); up(0); left(0); down(0);

//len=12; loc (80,80);

//dr(); right();ur(); up();ul(); ur();up();ul();left(); dl();


len=24; loc (100,100);


if (durch < 100)
{
right (0); ur(0); up(0); ul(len >> 1); ur(len >> 1); up(0); ul(0); left(0); 
dl(60); dr (60); loc (100,190); dr(10); ur(10); ul(10); dl(10); // Auge auf
}

else

{right (0); ur(0); up(36); left(len >> 1); right(len >> 1); up(36); ul(0); left(0); 
dl(60); dr (60); loc (100,190); dr(10); ur(10); dl(10); ul(10); // Auge zu
}

durch++;
if (durch==200) durch=0; 


}






//  ***** PROGRAMMBEISPIEL 02X ******

// Periodendauermessung mit Timer/Counter 1

// Ohne den systematischen Mefehler des Programmbeispiels 2

// Nutzung der Input_Capture-Funktion

// LCD an Ports B und C

// Das Mesignal kommt ber Port D, Bit 6

// Programmgrundlage: V3_15_template_LCD_B.c 

// Neue Variable: 


uint16_t wert;					// ein 16-Bit_Wort, das den binren Zahlenwert aufnimmt

// Einfgen:

DDRD  = 0b10111111;  			// Eingang ist ICP1 = Port D6 = Pin 20
	
TCCR1B=0x02; 					// T1 Maschinentakt : 8 (Periode 2 s). Normalbetrieb	
								
								
while (1)						// Die allgemeine Endlosschleife
{

TIFR=(TIFR |0b00100000);		// Das Merkflipflop zurcksetzen (Schreiben einer Eins)
while (!(TIFR &0x20));			// Auf das Capture-Ereignis warten (Warten, bis der nchste Impuls kommt)


TCNT1=0;						// Den Zhler lschen
TIFR=(TIFR |0b00100000);		// Das Merkflipflop zurcksetzen (Schreiben einer Eins)
while (!(TIFR &0x20));			// Auf das Capture-Ereignis warten. Whrenddessen wird von 0 an gezhlt

PORTA=(PORTA ^0x01);
PORTA=(PORTA | 0x02);

wert=ICR1;						// Den aufgeschnappten Wert lesen

lcd_kdo (lcd_row1);				// An den Anfang der ersten LCD-Zeile


lcd_dat((wert/10000) +0x30);	// Die Zehntausenderstelle anzeigen

wert=wert%10000;

lcd_dat((wert/1000) +0x30);		// Die Tausenderstelle anzeigen

wert=wert%1000;

lcd_dat(wert/100 +0x30);		// Die Hunderterstelle anzeigen

wert=wert%100;

lcd_dat(wert/10 +0x30);			// Die Zehnerstelle anzeigen

wert=wert%10;

lcd_dat(wert +0x30);			// Die Einerstelle anzeigen


TIFR=(TIFR |0b00100000);		// Das Merkflipflop zurcksetzen (Schreiben einer Eins)

}




//  ***** PROGRAMMBEISPIEL 02Y ******

// Periodendauermessung mit Timer/Counter 1. **** Frequenzanzeige ****

// Ohne den systematischen Mefehler des Programmbeispiels 2

// Nutzung der Input_Capture-Funktion

// LCD an Ports B und C

// Das Mesignal kommt ber Port D, Bit 6

// Programmgrundlage: V3_15_template_LCD_B.c 

// Neue Variable: 

uint32_t hilf;


// Die Endlosschleife

while (1)						// Die allgemeine Endlosschleife
{
TIFR=(TIFR |0b00100000);		// Das Merkflipflop zurcksetzen (Schreiben einer Eins)

while (!(TIFR &0x20));			// Auf das Capture-Ereignis warten


TCNT1=0;						// Den Zhler lschen
TIFR=(TIFR |0b00100000);		// Das Merkflipflop zurcksetzen (Schreiben einer Eins)
while (!(TIFR &0x20));			// Auf das Capture-Ereignis warten

PORTA=(PORTA ^0x01);
PORTA=(PORTA | 0x02);

hilf=ICR1;						// Den aufgeschnappten Wert lesen


wert=500000/hilf;				// Die Frequenz ist der Kehrwert der Periodendauer

								// wenn wir mit s rechnen, ergeben sich MHz. 
								// Also mssen wir auf 1 Millon Hz skalieren.
								// Gemessener Wert in s = ICR-Inhat * 2 (Zhltakt = 4 MHz : 8)
								// Kehrwert also 1 000 000 : 2 * <ICR>

lcd_kdo (lcd_row1);				// An den Anfang der ersten LCD-Zeile

lcd_dat((wert/10000) +0x30);	// Die Zehntausenderstelle anzeigen

wert=wert%10000;

lcd_dat((wert/1000) +0x30);		// Die Tausenderstelle anzeigen

wert=wert%1000;

lcd_dat(wert/100 +0x30);		// Die Hunderterstelle anzeigen

wert=wert%100;

lcd_dat(wert/10 +0x30);			// Die Zehnerstelle anzeigen

wert=wert%10;

lcd_dat(wert +0x30);			// Die Einerstelle anzeigen

PORTA=(PORTA & 0xfd);


}

 // ******************** E N D E **************************




